#!/usr/bin/env python

import unparse
import compiler
try:
	import ast
except ImportError:
	import _ast as ast

def astnode_genAssign( targets, value):
	tmp = ast.Assign( )
	tmp.targets = targets
	tmp.value = value
	tmp.lineno = 0
	#print tmp
	return tmp


#example weird mutator
#take an express x.func( y ) and turn it into x = y		
def mutateNode( node ):
	newAssign = astnode_genAssign( [node.value.func.value], node.value.args[0] )
	node.value = newAssign

src_text = """
a.set(1)
"""

tree = compile( src_text, "<string>", 'exec', ast.PyCF_ONLY_AST  )

#print out what the tree looks like
print "Before Mutation"
print unparse.UnparserStr( tree ).out_str
mutateNode( tree.body[0] )
#print out what the tree looks like after the mutation
print "After Mutation"
print unparse.UnparserStr( tree ).out_str
